git reset --hard -q 产生关于空格的错误
git reset --hard -q produces errors about whitespace
我正在为 运行 我的 Python 测试编写一个预提交挂钩,一切都运行良好......直到我遇到合并冲突。在此合并冲突中,引入了一些带有尾随空格的文档文件,每次我尝试提交时,我都会收到这些消息:
<stdin>:28: trailing whitespace.
Ticket Link:
<stdin>:54: trailing whitespace.
Then visit `http://app.dev`
<stdin>:13528: trailing whitespace.
//most be provided for ALL resource updates, and
<stdin>:13531: trailing whitespace.
"deleted": false, //indicates if this action resulted in a resource delete;
warning: squelched 415 whitespace errors
warning: 420 lines add whitespace errors.
fatal: could not open '.git/MERGE_HEAD' for reading: No such file or directory
然后当我打开我的编辑器来写提交消息时,它完全是空的。
我的预提交脚本是:
#!/bin/sh
RED='3[0;31m'
NC='3[0m'
proper_pop() {
git reset --hard -q
git stash apply -q --index && git stash drop -q
}
exit_and_pop() {
proper_pop
if [ "" -ne 0 ]; then
echo "${RED}Your code failed the pre-commit hook! Please examine the output and fix your issues!${NC}"
fi
exit
}
run_and_bail() {
bash -c "";
ret=$?;
if [ "${ret}" -ne 0 ]; then
exit_and_pop "${ret}"
fi
}
if git rev-parse --verify HEAD >/dev/null 2>&1
then
against=HEAD
else
# Initial commit: diff against an empty tree object
against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi
old_stash=$(git rev-parse -q --verify refs/stash)
git stash -q --keep-index
new_stash=$(git rev-parse -q --verify refs/stash)
if [ "$old_stash" = "$new_stash" ]; then
echo "pre-commit script: No changes to test. Not running."
sleep 1 # HACK: Editor may erase message if done too quickly, make the programmer read
exit 0
fi
# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --bool hooks.allownonascii)
# Redirect output to stderr.
exec 1>&2
# Cross platform projects tend to avoid non-ASCII filenames; prevent
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
# Note that the use of brackets around a tr range is ok here, (it's
# even required, for portability to Solaris 10's /usr/bin/tr), since
# the square bracket bytes happen to fall in the designated range.
test $(git diff --cached --name-only --diff-filter=A -z $against |
LC_ALL=C tr -d '[ -~][=12=]' | wc -c) != 0
then
cat <<\EOF
Error: Attempt to add a non-ASCII file name.
This can cause problems if you want to work with people on other platforms.
To be portable it is advisable to rename the file.
If you know what you are doing you can disable this check using:
git config hooks.allownonascii true
EOF
exit_and_pop 1
fi
if ! [ -z "$(which git-pylint-commit-hook)" ]; then
run_and_bail "git-pylint-commit-hook"
fi
if ! [ -z "$(which pep8)" ]; then
run_and_bail "python hooks/pep8-hook-check.py"
fi
proper_pop
通过我的调试,我已经制作了最小的脚本来重现这个错误:
#!/bin/sh
RED='3[0;31m'
NC='3[0m'
proper_pop() {
git reset --hard -q
git stash apply -q --index && git stash drop -q
}
exit_and_pop() {
proper_pop
if [ "" -ne 0 ]; then
echo "${RED}Your code failed the pre-commit hook! Please examine the output and fix your issues!${NC}"
fi
exit
}
run_and_bail() {
bash -c "";
ret=$?;
if [ "${ret}" -ne 0 ]; then
exit_and_pop "${ret}"
fi
}
if git rev-parse --verify HEAD >/dev/null 2>&1
then
against=HEAD
else
# Initial commit: diff against an empty tree object
against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi
old_stash=$(git rev-parse -q --verify refs/stash)
git stash -q --keep-index
new_stash=$(git rev-parse -q --verify refs/stash)
if [ "$old_stash" = "$new_stash" ]; then
echo "pre-commit script: No changes to test. Not running."
sleep 1 # HACK: Editor may erase message if done too quickly, make the programmer read
exit 0
fi
proper_pop
通过这个,我了解到 proper_pop
中的行:git reset --hard -q
是唯一的罪魁祸首(删除它可以消除错误)。没有安装其他挂钩,git 版本是:1.8.1.2
,但我也在 2.5.0
版本上 运行 这个,同样的问题发生了。有人任何知道发生了什么事吗?
我尝试通过管道将 stdout 和 stderr 传送到 /dev/null
以获得那个命令,只是为了看看它是否有效,但错误仍然打印出来...
这完全是一个我可以解决的问题,它确实不会引起任何问题,但我不希望技术水平较低的同事看到这个错误并让它把它们扔掉(而且我我不确定每次我们合并带有尾随空格的东西时是否会打印出来),所以我很想知道发生了什么以及如何解决这个问题(或者告诉 git reset
忽略尾随空格错误) .
编辑:
这是一个演示此问题的完整工作存储库:https://github.com/hjc1710/so-git-hook-question,只需按照 README.md
中的步骤操作,无论您是否处于合并中,您都会收到错误消息与否。
我的 git 配置(我的工作站在 1.8.x 上,我的笔记本电脑在 2.5.x 上)可以找到 here.敏感信息已被删除,但其中 none 应该是相关的。
正如 this answer 中的第二个脚注所指出的,git stash apply
仅调用 git diff ... | git apply --index
。警告来自这些命令。
当您有尾随空格时会发生这种情况,存储包含尾随空格的文件,然后应用存储。
更准确地说,每当您尝试 git apply
尾随换行符到代码体
时,它就会发生
如果您创建带有尾随空格的 git 补丁并尝试通过 cat a.patch | git diff --index
应用它,则会出现相同的错误结果。
至于解决这个问题,按理说在本地、全局或系统gitconfig
中设置core.whitespace=nowarn
会使其静音,但这似乎不是对我来说是真的,但是 YMMV。 (似乎没有读取这些设置)。 运行 git config core.whitespace -blank-at-eol
,正如评论中指出的那样。
除上述方法外,我看到的唯一解决方案是在 git-stash bash 脚本中找到有问题的行,并将 --whitespace=nowarn
参数添加到 git apply
, 你自己。我应该提到的是一个相当不标准、不可移植的解决方案。您必须让每个人都这样做,很可能每次 git 更新时也是如此。但如果他们无休止地打扰你——那你就可以做到。
从好的方面来说,正如你提到的,它可以解决,但如果我还没有的话,可能值得在 git 本身上打开一个错误把事情弄得一团糟,是甚至忽略了系统 gitconfig
。我希望它至少应该尊重这一点。
感谢您让这个重现如此简单!
问题似乎是挂钩内的 git 命令将空白错误写入当前 tty
而不是 stdout
或 stderr
。然后,hook runner 正在拾取错误,然后错误地声称它是 stdout
.
修复来自 我之前的一个问题。
#!/bin/sh
git stash > /dev/null
unbuffer sh -c 'git stash apply -q --index && git stash drop -q ' >/dev/null 2>&1
编辑:如果你想要OSX上的unbuffer程序,你可以使用指令here.
获取它
brew tap homebrew/dupes/expect
brew install homebrew/dupes/expect
我正在为 运行 我的 Python 测试编写一个预提交挂钩,一切都运行良好......直到我遇到合并冲突。在此合并冲突中,引入了一些带有尾随空格的文档文件,每次我尝试提交时,我都会收到这些消息:
<stdin>:28: trailing whitespace.
Ticket Link:
<stdin>:54: trailing whitespace.
Then visit `http://app.dev`
<stdin>:13528: trailing whitespace.
//most be provided for ALL resource updates, and
<stdin>:13531: trailing whitespace.
"deleted": false, //indicates if this action resulted in a resource delete;
warning: squelched 415 whitespace errors
warning: 420 lines add whitespace errors.
fatal: could not open '.git/MERGE_HEAD' for reading: No such file or directory
然后当我打开我的编辑器来写提交消息时,它完全是空的。
我的预提交脚本是:
#!/bin/sh
RED='3[0;31m'
NC='3[0m'
proper_pop() {
git reset --hard -q
git stash apply -q --index && git stash drop -q
}
exit_and_pop() {
proper_pop
if [ "" -ne 0 ]; then
echo "${RED}Your code failed the pre-commit hook! Please examine the output and fix your issues!${NC}"
fi
exit
}
run_and_bail() {
bash -c "";
ret=$?;
if [ "${ret}" -ne 0 ]; then
exit_and_pop "${ret}"
fi
}
if git rev-parse --verify HEAD >/dev/null 2>&1
then
against=HEAD
else
# Initial commit: diff against an empty tree object
against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi
old_stash=$(git rev-parse -q --verify refs/stash)
git stash -q --keep-index
new_stash=$(git rev-parse -q --verify refs/stash)
if [ "$old_stash" = "$new_stash" ]; then
echo "pre-commit script: No changes to test. Not running."
sleep 1 # HACK: Editor may erase message if done too quickly, make the programmer read
exit 0
fi
# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --bool hooks.allownonascii)
# Redirect output to stderr.
exec 1>&2
# Cross platform projects tend to avoid non-ASCII filenames; prevent
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
# Note that the use of brackets around a tr range is ok here, (it's
# even required, for portability to Solaris 10's /usr/bin/tr), since
# the square bracket bytes happen to fall in the designated range.
test $(git diff --cached --name-only --diff-filter=A -z $against |
LC_ALL=C tr -d '[ -~][=12=]' | wc -c) != 0
then
cat <<\EOF
Error: Attempt to add a non-ASCII file name.
This can cause problems if you want to work with people on other platforms.
To be portable it is advisable to rename the file.
If you know what you are doing you can disable this check using:
git config hooks.allownonascii true
EOF
exit_and_pop 1
fi
if ! [ -z "$(which git-pylint-commit-hook)" ]; then
run_and_bail "git-pylint-commit-hook"
fi
if ! [ -z "$(which pep8)" ]; then
run_and_bail "python hooks/pep8-hook-check.py"
fi
proper_pop
通过我的调试,我已经制作了最小的脚本来重现这个错误:
#!/bin/sh
RED='3[0;31m'
NC='3[0m'
proper_pop() {
git reset --hard -q
git stash apply -q --index && git stash drop -q
}
exit_and_pop() {
proper_pop
if [ "" -ne 0 ]; then
echo "${RED}Your code failed the pre-commit hook! Please examine the output and fix your issues!${NC}"
fi
exit
}
run_and_bail() {
bash -c "";
ret=$?;
if [ "${ret}" -ne 0 ]; then
exit_and_pop "${ret}"
fi
}
if git rev-parse --verify HEAD >/dev/null 2>&1
then
against=HEAD
else
# Initial commit: diff against an empty tree object
against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
fi
old_stash=$(git rev-parse -q --verify refs/stash)
git stash -q --keep-index
new_stash=$(git rev-parse -q --verify refs/stash)
if [ "$old_stash" = "$new_stash" ]; then
echo "pre-commit script: No changes to test. Not running."
sleep 1 # HACK: Editor may erase message if done too quickly, make the programmer read
exit 0
fi
proper_pop
通过这个,我了解到 proper_pop
中的行:git reset --hard -q
是唯一的罪魁祸首(删除它可以消除错误)。没有安装其他挂钩,git 版本是:1.8.1.2
,但我也在 2.5.0
版本上 运行 这个,同样的问题发生了。有人任何知道发生了什么事吗?
我尝试通过管道将 stdout 和 stderr 传送到 /dev/null
以获得那个命令,只是为了看看它是否有效,但错误仍然打印出来...
这完全是一个我可以解决的问题,它确实不会引起任何问题,但我不希望技术水平较低的同事看到这个错误并让它把它们扔掉(而且我我不确定每次我们合并带有尾随空格的东西时是否会打印出来),所以我很想知道发生了什么以及如何解决这个问题(或者告诉 git reset
忽略尾随空格错误) .
编辑:
这是一个演示此问题的完整工作存储库:https://github.com/hjc1710/so-git-hook-question,只需按照 README.md
中的步骤操作,无论您是否处于合并中,您都会收到错误消息与否。
我的 git 配置(我的工作站在 1.8.x 上,我的笔记本电脑在 2.5.x 上)可以找到 here.敏感信息已被删除,但其中 none 应该是相关的。
正如 this answer 中的第二个脚注所指出的,git stash apply
仅调用 git diff ... | git apply --index
。警告来自这些命令。
当您有尾随空格时会发生这种情况,存储包含尾随空格的文件,然后应用存储。
更准确地说,每当您尝试 git apply
尾随换行符到代码体
如果您创建带有尾随空格的 git 补丁并尝试通过 cat a.patch | git diff --index
应用它,则会出现相同的错误结果。
至于解决这个问题,按理说在本地、全局或系统 运行 gitconfig
中设置core.whitespace=nowarn
会使其静音,但这似乎不是对我来说是真的,但是 YMMV。 (似乎没有读取这些设置)。git config core.whitespace -blank-at-eol
,正如评论中指出的那样。
除上述方法外,我看到的唯一解决方案是在 git-stash bash 脚本中找到有问题的行,并将 --whitespace=nowarn
参数添加到 git apply
, 你自己。我应该提到的是一个相当不标准、不可移植的解决方案。您必须让每个人都这样做,很可能每次 git 更新时也是如此。但如果他们无休止地打扰你——那你就可以做到。
从好的方面来说,正如你提到的,它可以解决,但如果我还没有的话,可能值得在 git 本身上打开一个错误把事情弄得一团糟,是甚至忽略了系统 gitconfig
。我希望它至少应该尊重这一点。
感谢您让这个重现如此简单!
问题似乎是挂钩内的 git 命令将空白错误写入当前 tty
而不是 stdout
或 stderr
。然后,hook runner 正在拾取错误,然后错误地声称它是 stdout
.
修复来自
#!/bin/sh
git stash > /dev/null
unbuffer sh -c 'git stash apply -q --index && git stash drop -q ' >/dev/null 2>&1
编辑:如果你想要OSX上的unbuffer程序,你可以使用指令here.
获取它brew tap homebrew/dupes/expect
brew install homebrew/dupes/expect